/*
 * FadeTween.c
 *
 * Created: 02.08.2012 19:35:55
 *  Author: Unknown
 */ 

#include "FadeTween.h"

#include <avr/io.h>

FadeTween::FadeTween() {
	this->m_clk = Clock();
	this->m_clk.reset();
	m_startR = m_startG = m_startB = 0;
	m_destR = m_destG = m_destB = 0x00;
	m_fadeTime = 1;
	Done = false;
}

void FadeTween::setNext(uint8_t r, uint8_t g, uint8_t b, uint16_t fadeTime) {
	update();
	this->m_startR = R;
	this->m_startG = G;
	this->m_startB = B;
	this->m_destR = r;
	this->m_destG = g;
	this->m_destB = b;
	this->m_fadeTime = (fadeTime > 0) ? fadeTime : 1;
	this->m_clk.reset();
	this->Done = false;
}

void FadeTween::update() {
	if (Done)
		return;
	
	// Calculate our 'percent' range (0 - 255)
	uint32_t elapsed = this->m_clk.getElapsed();
	if (elapsed >= this->m_fadeTime) 
	{
		elapsed = this->m_fadeTime;
		Done = true;
	}		
		
	// TODO(mlinder): Check why simple uint16_t won't work here. Type casting magic?
	uint32_t perc = (uint32_t)elapsed * 255UL / (uint32_t)this->m_fadeTime;
	uint32_t invPerc = 255UL - perc;
		
	// LERP the color
	R = (uint8_t)(((uint32_t)m_startR * invPerc + (uint32_t)m_destR * perc) / 255UL);
	G = (uint8_t)(((uint32_t)m_startG * invPerc + (uint32_t)m_destG * perc) / 255UL);	
	B = (uint8_t)(((uint32_t)m_startB * invPerc + (uint32_t)m_destB * perc) / 255UL);
}