/*
 * rgbpwm.cpp
 *
 * Created: 02.08.2012 19:34:15
 *  Author: Unknown
 */ 

#include "RgbLed.h"
#include <avr/interrupt.h>

volatile uint8_t RgbTimes[3];
volatile uint8_t Ticks;

void RgbLed::start() {
	// Setup and enable Timer0
	GTCCR |= _BV(TSM);
	{
		TCCR0A = _BV(WGM01); // CTC
		TCCR0B = _BV(CS01); // div 8
		OCR0A = 48; // => 20,8 kHz (81hz per round) .. should take 10% of cpu time
		TIMSK |= _BV(OCIE0A); // enable Output Compare Match A interrupt
	}
	GTCCR &= ~_BV(TSM);
	
	// Set LEDs as output
	PORT |= PIN_RGB_MASK; // off
	DDR |= PIN_RGB_MASK;
	
	// Update Ticks
	Ticks = 0;
}

void RgbLed::stop() {
	// Disable Timer0
	TCCR0B = 0;
	
	// Set LEDs as input
	DDR &= ~PIN_RGB_MASK;
	PORT &= ~PIN_RGB_MASK; // off
}	
 
void RgbLed::setColor(uint8_t index, uint8_t val) {
	RgbTimes[index] = val;
}	
 
void RgbLed::setColor(uint8_t r, uint8_t g, uint8_t b) {
	RgbTimes[0] = r;
	RgbTimes[1] = g;
	RgbTimes[2] = b;
}