
/*
 * RGB PWMing
 *
 * Created: 02.08.2012 19:58:50
 * Author: mlinder
 */ 
 
 #include <avr/io.h>

 // Settings
 DDR = _SFR_IO_ADDR(DDRB)
 PORT = _SFR_IO_ADDR(PORTB)
 PIN_R = (1 << PB1)
 PIN_G = (1 << PB3)
 PIN_B = (1 << PB4)
 STATUS = 0x3F
 PIN_RGB_MASK = (PIN_R | PIN_G | PIN_B)

 // Define some registers/vars we will be using
 port = 16
 ticks = 17
 data = 18
 
 // Speicher
 .extern RgbTimes
 .comm Ticks, 1

 // ISR for TIMER0_COMPA
 .global TIMER0_COMPA_vect
 TIMER0_COMPA_vect:
    push ticks
	in ticks, STATUS // save SREG
	sei
	push ticks
	push port
	push data

	// Load and increase our counter
	lds ticks, Ticks // ticks
	inc ticks
	sts Ticks, ticks

	// Skip to the end for 0xFF (continous)
	cpi ticks, 0xFF
	breq end // if (ticks == 255) goto end

	// Enable all colors
	ldi port, 0

	// Check Red
	lds data, RgbTimes + 0 // R
	cp ticks, data
	brlo checkGreen // don't turn off if ticks < data
	ori port, PIN_R // -> off

	// Check Green
  checkGreen:
	lds data, RgbTimes + 1 // G
	cp ticks, data
	brlo checkBlue
	ori port, PIN_G

	// Check Blue
  checkBlue:
	lds data, RgbTimes + 2 // B
	cp ticks, data
	brlo setPort
	ori port, PIN_B

	// Write the new port
  setPort:
    cli
    in data, PORT
	andi data, ~PIN_RGB_MASK
	or data, port
	out PORT, port

	// Restore the stack and registers
  end:
    cli
	pop data
	pop port
	pop ticks
	out STATUS, ticks
	pop ticks
	reti
// END isr