/*
 * clock.cpp
 *
 * Created: 30.03.2012 18:29:44
 *  Author: Unknown
 */ 

#include "clock.h"
#include <avr/io.h>

#define DIV(a) ((uint16_t)((uint32_t)a * 10500UL / 9760UL)) // fix scale + make time go a little faster

// Maximum duration: 65 sec
// Polling required: every 256ms
// Resolution: 1ms

void setupClocks() {
	// div 8192 = 976 Hz
	TCCR1 = (1 << CS13) | (1 << CS12) | (1 << CS11) | (0 << CS10);
}

Clock::Clock() {
	this->reset();
}

void Clock::reset() {
	this->ticksStart = TCNT1;
	this->ticksOffset = 0;
}

uint16_t Clock::getElapsed() {
	uint8_t now = TCNT1;
	
	if (now < this->ticksStart) {
		this->ticksOffset += 256 - (uint16_t)this->ticksStart + (uint16_t)now;
		this->ticksStart = now;
	}
	else {
		this->ticksOffset += now - ticksStart;
		this->ticksStart = now;
	}		
	return DIV(this->ticksOffset);
}